﻿using System;
using System.Threading;

namespace CountDownTimerEventArgs
{
    public class CountDownTimer
    {
        public event EventHandler<TickEventArgs> Tick;
        public event EventHandler Finished;
        private readonly uint _seconds;

        public CountDownTimer(uint seconds)
        {
            _seconds = seconds;
        }

        public void Start()
        {
            new Thread(() =>
            {
                uint n = _seconds;

                while (n > 0u)
                {
                    var tick = Tick;
                    if (tick != null) tick(this, new TickEventArgs(n));
                    Thread.Sleep(1000);
                    n--;

                }
                var finished = Finished;
                if (finished != null)
                {
                    finished(this, EventArgs.Empty);
                }
            }).Start();
        }
    }
}
