﻿using System;
using System.Windows;
using CountDownTimerEventArgs;

namespace CountDownWpfApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private CountDownTimer _timer;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ButtonStartClicked(object sender, RoutedEventArgs e)
        {
            OutputField.Text = "Started";
            try
            {
                String timeString = InputField.Text;
                uint time = uint.Parse(timeString);
                _timer = new CountDownTimer(time);
                _timer.Tick += CountDownTick;
                _timer.Finished += CountDownFinished;
                _timer.Start();
            }
            catch (Exception ex)
            {
                OutputField.Text = ex.Message;
            }
        }

        private void CountDownTick(object sender, TickEventArgs e)
        {
            // http://www.beingdeveloper.com/use-dispatcher-in-wpf-to-build-responsive-applications/
            // Background thread (timer) cannot update GUI.
            // Dispatcher works on the GUI thread
            Dispatcher.Invoke(() => OutputField.Text = string.Format("{0} left", e.Seconds));
        }

        private void CountDownFinished(object sender, EventArgs e)
        {
            Dispatcher.Invoke(() => OutputField.Text = "Count down finished");
        }
    }
}
